Index: trunk/Assembly_Library/Inc/Delay.inc
===================================================================
--- trunk/Assembly_Library/Inc/Delay.inc	(revision 566)
+++ trunk/Assembly_Library/Inc/Delay.inc	(revision 567)
@@ -30,8 +30,8 @@
 ;
 ; LOOP instruction uses two bytes so aligned fetching will require:
-;   8088:		8 cycles (two BYTE reads)
-;   8086:		4 cycles (one WORD read)
-;   286:		2 cycles + wait states (usually 1)
-;   386:		?
+;	8088:		8 cycles (two BYTE reads)
+;	8086:		4 cycles (one WORD read)
+;	286:		2 cycles + wait states (usually 1)
+;	386:		?
 ;	486:		Fetched only once to internal cache
 ;
Index: trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 566)
+++ trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 567)
@@ -65,5 +65,5 @@
 ;	Parameters:
 ;		DS:		BDA segment (zero)
-;		AX:     Parameter to Format
+;		AX:		Parameter to Format
 ;		ES:DI:	Ptr to cursor location in video RAM
 ;	Returns:
@@ -94,5 +94,5 @@
 DisplayFormatCompressed_Format_5_x:
 	mov		si,16						; hex output, change base to 16
-	mov		bx,(04<<8) + 'h'	        ; 4 bytes, with postfix character 'h' to emit
+	mov		bx,(04<<8) + 'h'			; 4 bytes, with postfix character 'h' to emit
 										; (note that the count includes the 'h')
 	jmp		DisplayFormatCompressed_Format_u
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 566)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 567)
@@ -400,5 +400,5 @@
 ;	Parameters:
 ;		AL:		Character to display
-;               Zero value is ignored (no character is printed)
+;				Zero value is ignored (no character is printed)
 ;		DS:		BDA segment (zero)
 ;		ES:DI:	Ptr to cursor location in video RAM
Index: trunk/Assembly_Library/Src/Serial/SerialServer.asm
===================================================================
--- trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 566)
+++ trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 567)
@@ -27,10 +27,10 @@
 ; SerialServer_SendReceive:
 ;	Parameters:
-;       DX:		Packed I/O port and baud rate
+;		DX:		Packed I/O port and baud rate
 ;		ES:SI:	Ptr to buffer (for data transfer commands)
 ;		SS:BP:	Ptr to SerialServer_Command structure
 ;	Returns:
 ;		AH:		INT 13h Error Code
-;       CX:     Number of 512-byte blocks transferred
+;		CX:		Number of 512-byte blocks transferred
 ;		CF:		Cleared if success, Set if error
 ;	Corrupts registers:
@@ -334,7 +334,7 @@
 ;	Returns:
 ;		BP/SI:	Checksum for written bytes, compared against ACK from server in .readLoop
-;		CX:     Zero
+;		CX:		Zero
 ;		DL:		Receive/Transmit Register address
-;		ES:DI:  Ptr to buffer
+;		ES:DI:	Ptr to buffer
 ;	Corrupts registers:
 ;		AX
@@ -401,13 +401,13 @@
 ;	Parameters:
 ;		AH:		UART_LineStatus bit to test (20h for write, or 1h for read)
-;               One entry point fills in AH with 20h for write
+;				One entry point fills in AH with 20h for write
 ;		DX:		Port address (OK if already incremented to UART_lineStatus)
-;       BX:
-;       Stack:	2 words on the stack below the command/count word
+;		BX:
+;		Stack:	2 words on the stack below the command/count word
 ;	Returns:
-;       Returns when desired UART_LineStatus bit is cleared
-;       Jumps directly to error exit if timeout elapses (and cleans up stack)
+;		Returns when desired UART_LineStatus bit is cleared
+;		Jumps directly to error exit if timeout elapses (and cleans up stack)
 ;	Corrupts registers:
-;       AX
+;		AX
 ;--------------------------------------------------------------------
 
Index: trunk/Assembly_Library/Src/Serial/SerialServerScan.asm
===================================================================
--- trunk/Assembly_Library/Src/Serial/SerialServerScan.asm	(revision 566)
+++ trunk/Assembly_Library/Src/Serial/SerialServerScan.asm	(revision 567)
@@ -31,7 +31,7 @@
 ; SerialServerScan_ScanForServer:
 ;	Parameters:
-;       BH:		Drive Select byte for Drive and Head Select Register
-;               0xAx: Scan for drive, low nibble indicates drive
-;               0x0:  Scan for Server, independent of drives
+;		BH:		Drive Select byte for Drive and Head Select Register
+;				0xAx: Scan for drive, low nibble indicates drive
+;				0x0:  Scan for Server, independent of drives
 ;		DX:		Port and Baud to Scan for
 ;				0: Scan a known set of ports and bauds
@@ -89,5 +89,5 @@
 ; Note: hardware baud multipliers (2x, 4x) will impact the final baud rate and are not known at this level
 ;
-		mov		dh,030h * 2	    ; multiply by 2 since we are about to divide by 2
+		mov		dh,030h * 2		; multiply by 2 since we are about to divide by 2
 		mov		dl,[cs:di]		; restore single byte port address for scan
 
@@ -119,10 +119,10 @@
 ; SerialServer_CheckForServer_PortAndBaudInDX:
 ;	Parameters:
-;       BH:		Drive Select byte for Drive and Head Select Register
-;               0xAx: Scan for drive, low nibble indicates drive
-;               0x0:  Scan for Server, independent of drives
+;		BH:		Drive Select byte for Drive and Head Select Register
+;				0xAx: Scan for drive, low nibble indicates drive
+;				0x0:  Scan for Server, independent of drives
 ;		DX:		Baud and Port
 ;		CH:		1: We are doing a scan for the serial server
-;               0: We are working off a specific port given by the user
+;				0: We are working off a specific port given by the user
 ;		CL:		1, for one sector to read
 ;		ES:SI:	Ptr to buffer for return
Index: trunk/Assembly_Library/Src/Util/Size.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Size.asm	(revision 566)
+++ trunk/Assembly_Library/Src/Util/Size.asm	(revision 567)
@@ -113,5 +113,10 @@
 	rcr		si, 1					; Update remainder
 	loop	.ShiftLoop
-	eSHR_IM	si, 6					; Remainder to SI beginning
+%ifdef USE_186
+	shr		si, 6					; Remainder to SI beginning
+%else
+	mov		cl, 6
+	shr		si, cl
+%endif
 	pop		cx
 	inc		cx						; Increment magnitude